#include <def21369.h>
#include <cdef21369.h>
#include "macros.h"
#include "ogg.h"

extern unsigned char databuffer1[PAGE_SIZE_IN]; /* take 8k out of the data segment, not the stack */
extern unsigned char databuffer2[PAGE_SIZE_IN]; /* take 8k out of the data segment, not the stack */

extern volatile int flash_offset;

volatile int data_ready = 0;
volatile int data_fill_count = 0;

void ExternalPortInit(void)
{	
	int dummy;
	
	*pDMAC0 = 0;
	
	*pIIEP0 = (unsigned int)databuffer1;
	*pIMEP0 = 1;
	*pCEP0 = PAGE_SIZE_IN;
	
	*pEIEP0 = FLASH_START_ADDRESS;
	*pEMEP0 = 1;
	
	*pDMAC0 = DEN;
	
	dummy = 1;

	flash_offset = flash_offset + PAGE_SIZE_IN;
}

void ExternalPort0Isr(int dummy)
{
	data_ready = 1;
	data_fill_count++;
}


void FillBufferFromFlash(int bufno)
{
    int temp = 0;
    
    temp = *pDMAC0 & EXTS;
	while( temp != 0 )
		temp = *pDMAC0 & EXTS; 

	*pDMAC0 = 0;

	*pCEP0 = PAGE_SIZE_IN;
	
	if( bufno == 1 )	
		*pIIEP0 = (unsigned int)databuffer1;
	else
		*pIIEP0 = (unsigned int)databuffer2;
	
	*pDMAC0 = DEN;
	
	flash_offset = flash_offset + PAGE_SIZE_IN;
}
