#include <sru.h>
#include <def21369.h>

// This function will setup the SRU Registers
void InitSRU()
{
	// Enable pull-up resistors on unused DAI pins
	* (volatile int *)DAI_PIN_PULLUP = 0xec00f;

	// Enable pull-up resistors on unused DPI pins
	* (volatile int *)DPI_PIN_PULLUP = 0x3fff;

	//Generating Code for connecting : SPORT2_CLK to SRC0_CLK_IP
	SRU (SPORT2_CLK_O, SRC0_CLK_IP_I); 

	//Generating Code for connecting : SPORT2_FS to SRC0_FS_IP
	SRU (SPORT2_FS_O, SRC0_FS_IP_I); 

	//Generating Code for connecting : SPORT2_DA to SRC0_DAT_IP
	SRU (SPORT2_DA_O, SRC0_DAT_IP_I); 

	//Generating Code for connecting : DAI_PIN5 to SPORT0_DA
	SRU (LOW, PBEN05_I); 
	SRU (DAI_PB05_O, SPORT0_DA_I); 

	//Generating Code for connecting : DAI_PIN7 to SPORT0_CLK
	SRU (LOW, PBEN07_I); 
	SRU (DAI_PB07_O, SPORT0_CLK_I); 

	//Generating Code for connecting : DAI_PIN7 to SRC0_CLK_OP
	SRU (LOW, PBEN07_I); 
	SRU (DAI_PB07_O, SRC0_CLK_OP_I); 

	//Generating Code for connecting : DAI_PIN7 to DAI_PIN13
	SRU (LOW, PBEN07_I); 
	SRU (HIGH, PBEN13_I); 
	SRU (DAI_PB07_O, DAI_PB13_I); 

	//Generating Code for connecting : DAI_PIN8 to SPORT0_FS
	SRU (LOW, PBEN08_I); 
	SRU (DAI_PB08_O, SPORT0_FS_I); 

	//Generating Code for connecting : DAI_PIN8 to SRC0_FS_OP
	SRU (LOW, PBEN08_I); 
	SRU (DAI_PB08_O, SRC0_FS_OP_I); 

	//Generating Code for connecting : DAI_PIN8 to DAI_PIN14
	SRU (LOW, PBEN08_I); 
	SRU (HIGH, PBEN14_I); 
	SRU (DAI_PB08_O, DAI_PB14_I); 

	//Generating Code for connecting : DAI_PIN17 to DAI_PIN6
	SRU (LOW, PBEN17_I); 
	SRU (HIGH, PBEN06_I); 
	SRU (DAI_PB17_O, DAI_PB06_I); 

	//Generating Code for connecting : SRC0_DAT_OP to DAI_PIN9
	SRU (HIGH, PBEN09_I); 
	SRU (SRC0_DAT_OP_O, DAI_PB09_I); 

	//Generating Code for connecting : SRC0_DAT_OP to DAI_PIN10
	SRU (HIGH, PBEN10_I); 
	SRU (SRC0_DAT_OP_O, DAI_PB10_I); 

	//Generating Code for connecting : SRC0_DAT_OP to DAI_PIN11
	SRU (HIGH, PBEN11_I); 
	SRU (SRC0_DAT_OP_O, DAI_PB11_I); 

	//Generating Code for connecting : SRC0_DAT_OP to DAI_PIN12
	SRU (HIGH, PBEN12_I); 
	SRU (SRC0_DAT_OP_O, DAI_PB12_I); 


}
