#include <def21369.h>
#include <cdef21369.h>
#include <21369.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "macros.h"
#include "ogg.h"

unsigned char Get_Byte_Data(unsigned char *buffer_ptr,int position);

extern void FillBufferFromFlash(int bufno);

extern volatile int flash_offset;
extern volatile int data_ready;
extern volatile int data_process_count;
extern volatile int data_fill_count;

extern unsigned char databuffer1[PAGE_SIZE_IN]; /* take 8k out of the data segment, not the stack */
extern unsigned char databuffer2[PAGE_SIZE_IN]; /* take 8k out of the data segment, not the stack */

extern volatile int eos;

volatile int continued=0;
volatile int bos=0;
volatile int total_pages = 0;
volatile int no_of_packets = 0;
volatile int total_packets = 0;
volatile int current_pageno = 0;
volatile int current_pagesize = 0;
volatile int current_packet = 0;
volatile int current_packetsize = 0;
volatile int segment_table[255];
volatile ogg_int64_t granulepos=0;
volatile int serialno=0;
volatile int header_bytes = 0;
volatile int packets_in_prev_page = 0;
volatile int packet_eos = 0;
volatile int no_of_exceeded = 0;

volatile int read_ptr = 0;
unsigned char *page_ptr = databuffer1; 
unsigned char *prev_page_ptr;

volatile int page_ptr_position = 0;
volatile int prev_page_ptr_position = 0;
volatile int read_ptr_position = 0;
	
int ExtractPageInfo(void)
{
	int i = 0;
	int bodybytes = 0;
	int version=0;
	long pageno=0;
	int segments=0;
	int segptr=0;

	int bytes;

	char chksum[4];
	unsigned char start_data[5];
	unsigned char *temp_ptr;
	int temp_ptr_position;

	int temp;
	
	temp_ptr = page_ptr;
	temp_ptr_position = page_ptr_position;
	for( i = 0; i < 5; i++ )
	{
		start_data[i] = Get_Byte_Data(temp_ptr,temp_ptr_position);
		temp_ptr_position++;
		if(temp_ptr_position > 3 )
		{
			temp_ptr_position -= 4;
			temp_ptr = circptr(temp_ptr,1,databuffer1,INPUT_BUFLEN);
		} 
	}
	if(memcmp(start_data,"OggS",4) != 0 )
	{
		page_ptr_position++;
		if(page_ptr_position > 3 )
		{
			page_ptr_position -= 4;
			page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
		}
		
		read_ptr_position++;
		if(read_ptr_position > 3 )
		{
			read_ptr_position -= 4;
			read_ptr++;
		}
		if(memcmp(start_data+1,"OggS",4) != 0 )
		{
			eos = 1;
			return -1;		
		}
	}
	else
	{
		page_ptr_position = page_ptr_position + 4;
		if(page_ptr_position > 3 )
		{
			page_ptr_position -= 4;
			page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
		}
		read_ptr_position = read_ptr_position + 4;
		if(read_ptr_position > 3 )
		{
			read_ptr_position -= 4;
			read_ptr++;
		}
	}
	
	version = Get_Byte_Data(page_ptr,page_ptr_position);
	page_ptr_position++;
	if(page_ptr_position > 3 )
	{
		page_ptr_position -= 4;
		page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
	}
	read_ptr_position++;
	if(read_ptr_position > 3 )
	{
		read_ptr_position -= 4;
		read_ptr++;
	}
	
	continued = (Get_Byte_Data(page_ptr,page_ptr_position)) & 0x01;
	bos = (Get_Byte_Data(page_ptr,page_ptr_position)) & 0x02;
	eos = (Get_Byte_Data(page_ptr,page_ptr_position)) & 0x04;

	page_ptr_position++;
	if(page_ptr_position > 3 )
	{
		page_ptr_position -= 4;
		page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
	}
	read_ptr_position++;
	if(read_ptr_position > 3 )
	{
		read_ptr_position -= 4;
		read_ptr++;
	}
	
	granulepos = 0;
	for( i = 0; i < 8; i++ )
	{
		if( i < 4 )
			granulepos |=  ((Get_Byte_Data(page_ptr,page_ptr_position)&0xFF) << (i*8));
		
		page_ptr_position++;
		if(page_ptr_position > 3 )
		{
			page_ptr_position -= 4;
			page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
		}
	}
	
	read_ptr_position = read_ptr_position + 8;
	while(read_ptr_position > 3 )
	{
		read_ptr_position -= 4;
		read_ptr++;
	}
	serialno = 0;
	for( i = 0; i < 4; i++ )
	{
		serialno |=  ((Get_Byte_Data(page_ptr,page_ptr_position)&0xFF) << (i*8));

		page_ptr_position++;
		if(page_ptr_position > 3 )
		{
			page_ptr_position = 0;
			page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
		}
	
	}
	
	read_ptr_position = read_ptr_position + 4;
	if(read_ptr_position > 3 )
	{
		read_ptr_position -= 4;
		read_ptr++;
	}
	
	pageno = 0;
	for( i = 0; i < 4; i++ )
	{
		pageno |=  ((Get_Byte_Data(page_ptr,page_ptr_position)&0xFF) << (i*8));

		page_ptr_position++;
		if(page_ptr_position > 3 )
		{
			page_ptr_position -= 4;
			page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
		}

	}
	
	read_ptr_position = read_ptr_position + 4;
	if(read_ptr_position > 3 )
	{
		read_ptr_position -= 4;
		read_ptr++;
	}
		
	current_pageno = pageno;
	total_pages++;
	
	for( i = 0; i < 4; i++ )
	{
		chksum[i] =  Get_Byte_Data(page_ptr,page_ptr_position);

		page_ptr_position++;
		if(page_ptr_position > 3 )
		{
			page_ptr_position -= 4;
			page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
		}


	}
	read_ptr_position = read_ptr_position + 4;
	if(read_ptr_position > 3 )
	{
		read_ptr_position -= 4;
		read_ptr++;
	}
	
	segments = Get_Byte_Data(page_ptr,page_ptr_position);
    total_packets = segments;
    header_bytes = segments+27;
    
	page_ptr_position++;
	if(page_ptr_position > 3 )
	{
		page_ptr_position -= 4;
		page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
	}

    read_ptr_position++;
	if(read_ptr_position > 3 )
	{
		read_ptr_position -= 4;
		read_ptr++;
	}
	
	bodybytes = 0;
	for(i=0;i<segments;i++)
	{
		bodybytes+=Get_Byte_Data(page_ptr,page_ptr_position);
		segment_table[i] =Get_Byte_Data(page_ptr,page_ptr_position);

		page_ptr_position++;
		if(page_ptr_position > 3 )
		{
			page_ptr_position -= 4;
			page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
		}
	}
	
	current_pagesize = bodybytes;
	read_ptr_position = read_ptr_position+segments;
	while(read_ptr_position > 3 )
	{
		read_ptr_position -= 4;
		read_ptr++;
	}
	
	if(version>0)
  	{
	  return(-1);
  	}

  	return(0);
}

int ExtractPacketInfo(void)
{
	int bytes;
	int size;
	int result = 0;
	int temp;
	
	if(current_packet >= total_packets)
	{
		current_packet = 0;
		result = ExtractPageInfo();
		if( result != 0 )
			return -1;
	}
	
	size = segment_table[current_packet++] & 0xFF;			
	bytes = size;
	
	if( eos != 0 )
  		packet_eos = 0x200;
		
	while(size == 255)
	{
		if( ( current_packet == total_packets ) && (size == 255))
		{
			packets_in_prev_page = bytes;
			prev_page_ptr = page_ptr;
			prev_page_ptr_position = page_ptr_position;
			
	//		read_ptr = read_ptr + bytes;
	//		page_ptr = circptr(page_ptr,bytes,databuffer1,INPUT_BUFLEN);
			read_ptr_position = read_ptr_position+bytes;
			while(read_ptr_position > 3 )
			{
				read_ptr_position -= 4;
				read_ptr++;
			}
			page_ptr_position = page_ptr_position+bytes;
			while(page_ptr_position > 3 )
			{
				page_ptr_position -= 4;
				page_ptr = circptr(page_ptr,1,databuffer1,INPUT_BUFLEN);
			}
											
			current_packet = 0;
			result = ExtractPageInfo();
			if( result != 0 )
				break;
			size = segment_table[current_packet++] & 0xFF;
			bytes+=size;
			
			
		} 
		else
		{
			size = segment_table[current_packet++] & 0xFF;
			bytes+=size;
		}
	}
	
	no_of_packets++;
	
	if( result == 0 )
	{		
		current_packetsize = bytes;	
		return 0;
	}
	else
		return -1;
}


unsigned char Get_Byte_Data(unsigned char *buffer_ptr,int position)
{
	if( position == 0 )
		return (*buffer_ptr) & 0x000000FF;
	else if( position == 1 )
		return ((*buffer_ptr) & 0x0000FF00) >> 8;	
	else if( position == 2 )
		return ((*buffer_ptr) & 0x00FF0000) >> 16;
	else 
		return ((*buffer_ptr) & 0xFF000000) >> 24;
}



